routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    if(Auth::check()){
        return redirect('/home');
    }
    return view('welcome');
});
Auth::routes();

Route::get('/home', 'HomeController@index')->name('home')->middleware('auth');

Route::group(['middleware' => 'auth'], function () {
		Route::get('icons', ['as' => 'pages.icons', 'uses' => 'PageController@icons']);
		Route::get('maps', ['as' => 'pages.maps', 'uses' => 'PageController@maps']);
		Route::get('notifications', ['as' => 'pages.notifications', 'uses' => 'PageController@notifications']);
		Route::get('rtl', ['as' => 'pages.rtl', 'uses' => 'PageController@rtl']);
		Route::get('tables', ['as' => 'pages.tables', 'uses' => 'PageController@tables']);
		Route::get('typography', ['as' => 'pages.typography', 'uses' => 'PageController@typography']);
		Route::get('upgrade', ['as' => 'pages.upgrade', 'uses' => 'PageController@upgrade']);
});

Route::group(['middleware' => 'auth'], function () {
    Route::post('user/{username}/find', ['as' => 'user.find', 'uses' => 'UserController@find']);
	Route::resource('user', 'UserController', ['except' => ['show']]);
	Route::get('profile', ['as' => 'profile.edit', 'uses' => 'ProfileController@edit']);
	Route::put('profile', ['as' => 'profile.update', 'uses' => 'ProfileController@update']);
	Route::put('profile/password', ['as' => 'profile.password', 'uses' => 'ProfileController@password']);
});

Route::group(['middleware' => 'auth'], function () {
    Route::resource('transfer', 'TransferController');
});

Route::group(['middleware' => 'auth'], function () {
    Route::resource('transaction', 'TransactionController');
});

app/Transfer.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Transfer extends Model
{
    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'transfers';

    /**
     * Get from user.
     */
    public function from_user()
    {
        return $this->belongsTo('App\User', 'from_id');
    }

    /**
     * Get to user.
     */
    public function to_user()
    {
        return $this->belongsTo('App\User', 'to_id');
    }

    /**
     * Get deposit detail.
     */
    public function deposit()
    {
        return $this->belongsTo('App\Transaction', 'deposit_id');
    }

    /**
     * Get withdraw detail.
     */
    public function withdraw()
    {
        return $this->belongsTo('App\Transaction', 'withdraw_id');
    }
}

app/Http/Controllers/TransferController.php
<?php

namespace App\Http\Controllers;

use App\User;
use Illuminate\Http\Request;
use App\Http\Requests\TransferRequest;

class TransferController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('transfer.form');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(TransferRequest $request)
    {
        $user = User::where('username', $request->username)->first();
        auth()->user()->transfer($user, (int)str_replace(',', '', $request->amount));
        return back()->withStatus(__('Transfer successfully.'));
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/transfer/form.blade.php
@extends('layouts.app', ['page' => __('Transfer'), 'pageSlug' => 'transfer'])

@section('content')
    <div class="row">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">
                    <h5 class="title">{{ _('Transfer Form') }}</h5>
                </div>
                <form method="post" action="{{ route('transfer.store') }}" autocomplete="off">
                    <div class="card-body">
                        @csrf
                        @include('alerts.success')

                        <div class="form-group">
                            <label>{{ _('Username') }}</label>
                            <div class="input-group{{ $errors->has('username') ? ' has-danger' : '' }}">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <i class="tim-icons icon-badge"></i>
                                    </div>
                                </div>
                                <input type="text" name="username" class="form-control{{ $errors->has('username') ? ' is-invalid' : '' }}" 
                                    placeholder="{{ _('Username') }}" value="{{ old('username') }}" onkeyup="search_username($(this))">
                                @include('alerts.feedback', ['field' => 'username'])
                            </div>
                        </div>

                        <div class="form-group">
                            <small class="text-muted search-progress" style="display:none;">search username<span class="progress-dot">...</span></small>
                            <ul class="nav nav-search" style="display:none;"></ul>
                        </div>

                        <div class="form-group">
                            <label>{{ _('Amount') }}</label>
                            <div class="input-group{{ $errors->has('amount') ? ' has-danger' : '' }}">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <i class="tim-icons icon-money-coins"></i>
                                    </div>
                                </div>
                                <input type="text" name="amount" class="form-control{{ $errors->has('amount') ? ' is-invalid' : '' }}" 
                                    placeholder="{{ _('0') }}" value="{{ old('amount') }}">
                                @include('alerts.feedback', ['field' => 'amount'])
                            </div>
                        </div>
                    </div>
                    <div class="card-footer">
                        <button type="submit" class="btn btn-fill btn-primary">{{ _('Transfer Wallet') }}</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
@endsection

@push('js')
    <script>
        var username_progress = false;
        var request;
        var i = 0;
        var timer;

        function search_username(elm){
            $('.search-progress').css('display', 'block');
            $('.nav-search').css('display', 'none');
            if(username_progress){
                // stop ajax and inteval
                request.abort();
                clearInterval(timer);
            }
            username_progress = true;
            i = 0;
            timer = setInterval(function() {
                i = ++i % 5;
                $(".progress-dot").html(Array(i+1).join("."));
            }, 800);
            request = $.ajax({
                url: '{{ route("user.index")}}/'+elm.val()+'/find',
                type: "POST",
                data:{_token: '{{ csrf_token() }}'},
                success: function (response) {
                    var html = '';
                    for (let index = 0; index < response.length; index++) {
                        html += '<li class="nav-item"><a class="nav-link" onclick="set_username($(this))" href="#" data-value="'+response[index]+'">'+response[index]+'</a></li>';
                    }
                    $('.search-progress').css('display', 'none');
                    $('.nav-search').html(html);
                    $('.nav-search').css('display', 'flex');
                    request.abort();
                    clearInterval(timer);
                },
                error: function (e) {
                    // console.log(e);
                }
            });
        }

        function set_username(elm){
            $('input[name="username"]').val(elm.attr('data-value'));
        }

        $('input[name="amount"]').on('change', function(){
            var number = $(this).val();
            number = number.replace(/\,/g,'');
            if(parseInt(number)){
                number = parseInt(number);
            }else{
                number = parseInt("0");
            }
            if(number == '0'){ 
                number = ''; 
            }else{
                number = number.toLocaleString()
            }
            $(this).val(number);
        });
    </script>
@endpush